summaryrefslogtreecommitdiff
path: root/tests/split
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2011-04-29 13:41:19 +0200
committerJim Meyering <meyering@redhat.com>2011-05-06 22:54:51 +0200
commit2644e288e4f12958f34d88976422ff887d1ffed2 (patch)
tree9bb94b8d5b0aaf2aa21783a15df049b94b290599 /tests/split
parenta09d9e5badacd08058a23dea97bec4e93c0e689a (diff)
downloadcoreutils-2644e288e4f12958f34d88976422ff887d1ffed2.tar.xz
tests: test split's new --filter=CMD option
* tests/Makefile.am (TESTS): Add split/filter. * tests/split/filter: New file.
Diffstat (limited to 'tests/split')
-rwxr-xr-xtests/split/filter45
1 files changed, 45 insertions, 0 deletions
diff --git a/tests/split/filter b/tests/split/filter
new file mode 100755
index 000000000..88321c0dc
--- /dev/null
+++ b/tests/split/filter
@@ -0,0 +1,45 @@
+#!/bin/sh
+# Exercise split's new --filter option.
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ split
+
+for total_n_lines in 5 3000 20000; do
+ seq $total_n_lines > in || framework_failure_
+ for i in 2 51 598; do
+
+ # Don't create too many files/processes.
+ # Starting 10k (or even "only" 1500) processes would take a long time,
+ # and would provide little added benefit.
+ case $i:$total_n_lines in 2:5);; *) continue;; esac
+
+ split -l$i --filter='xz > $FILE.xz' in out- || fail=1
+ xz -dc out-* > out || fail=1
+ compare in out || fail=1
+ rm -f out*
+ done
+ rm -f in
+done
+
+# Show how --elide-empty-files works with --filter:
+# split does not run the command (and effectively elides the file)
+# only when the output to that command would have been empty.
+split -e -n 10 --filter='xz > $FILE.xz' /dev/null || fail=1
+stat x?? 2>/dev/null && fail=1
+
+Exit $fail